"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var regex_parser_1 = __importDefault(require("regex-parser"));
var MiddlewareSearcher = /** @class */ (function () {
    function MiddlewareSearcher(directorySearcher, options) {
        this.directorySearcher = directorySearcher;
        this.options = options;
    }
    Object.defineProperty(MiddlewareSearcher.prototype, "isMiddleware", {
        get: function () {
            return regex_parser_1.default("/_middleware(" + this.options.ext.join("|") + ")/");
        },
        enumerable: true,
        configurable: true
    });
    MiddlewareSearcher.prototype.search = function (directory) {
        var _this = this;
        if (directory === void 0) { directory = this.options.basedir; }
        var results = this.directorySearcher.search(directory).filter(function (routes) {
            var isMiddleware = _this.isMiddleware;
            var isMiddlewareResult = isMiddleware.test(routes.filepath);
            return isMiddlewareResult;
        });
        return results.map(function (x) {
            x.relativePath = x.relativePath.replace(/_middleware$/, "");
            return x;
        });
    };
    return MiddlewareSearcher;
}());
exports.MiddlewareSearcher = MiddlewareSearcher;
