"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var regex_parser_1 = __importDefault(require("regex-parser"));
var RouterSearcher = /** @class */ (function () {
    function RouterSearcher(directorySearcher, options) {
        this.directorySearcher = directorySearcher;
        this.options = options;
    }
    Object.defineProperty(RouterSearcher.prototype, "isMiddleware", {
        get: function () {
            return regex_parser_1.default("/_middleware.(" + this.options.ext.join("|") + ")/");
        },
        enumerable: true,
        configurable: true
    });
    RouterSearcher.prototype.search = function (directory) {
        var _this = this;
        if (directory === void 0) { directory = this.options.basedir; }
        return this.directorySearcher.search(directory).filter(function (routes) {
            return !_this.isMiddleware.test(routes.filepath);
        });
    };
    return RouterSearcher;
}());
exports.RouterSearcher = RouterSearcher;
